﻿//-----------------------------------------------------------------------
// <copyright file="BallThrower.cs" company="Google">
//
// Copyright 2016 Google Inc. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// </copyright>
//-----------------------------------------------------------------------
using System.Collections;
using UnityEngine;
using Assets;


/// <summary>
/// Class for throwing balls.
/// </summary>
public class BallThrower : MonoBehaviour
{
	//GvrController.EmulatorConnectionMode
	public GameObject ballPrefab;
	public Camera mainCamera;
    //private float forwardVelocity = 5.0f;
    public GameObject exp;
	private GameObject[] ballArray = new GameObject[800];
	private int currentBallID = 0;

	/// <summary>
	/// Use this for initialization.
	/// </summary>
	private void Start()
	{
		for (int i = 0; i < ballArray.Length; i++)
		{
			ballArray[i] = (GameObject)Instantiate(ballPrefab);
			ballArray[i].SetActive(false);
			ballArray[i].transform.parent = transform;
		}

		currentBallID = 0;
	}

    System.Random rnd = new System.Random();
	/// <summary>
	/// Update is called once per frame.
	/// </summary>
	private void Update()
	{
		/*if (Input.GetKeyDown(KeyCode.Space))
        {
            ballArray[currentBallID].transform.position = mainCamera.transform.position - (mainCamera.transform.up * ballPrefab.transform.localScale.y);
            ballArray[currentBallID].GetComponent<Rigidbody>().velocity = (mainCamera.transform.forward * forwardVelocity) + (mainCamera.transform.up * forwardVelocity / 2);
            ballArray[currentBallID].SetActive(true);
            currentBallID = (currentBallID + 1) % ballArray.Length;
        }*/
        if (Input.GetMouseButtonDown(0)) {
            SwipeDetector.velocitySwipe = 0.8f;
        }
		if (SwipeDetector.mMessageIndex.Equals(3) || Input.GetMouseButtonDown(0))
		{print("CB:" + currentBallID);
			ballArray[currentBallID].transform.position = mainCamera.transform.position - (mainCamera.transform.up * ballPrefab.transform.localScale.y);
			ballArray[currentBallID].GetComponent<Rigidbody>().velocity = (mainCamera.transform.forward * SwipeDetector.velocitySwipe) + (mainCamera.transform.up * SwipeDetector.velocitySwipe / 2);
            print("VEL:" + SwipeDetector.velocitySwipe);
            ballArray[currentBallID].SetActive(true);
            int bid = rnd.Next(1, 5000000);
            currentBallID = (currentBallID + 1);//% ballArray.Length;
            
            
            SwipeDetector.mMessageIndex = 0;
			//GameObject g = (GameObject)Instantiate(bulletObject, transform.position + transform.forward * 3, transform.rotation);
			//GameObject g = (GameObject)Instantiate(bulletObject, transform.position + transform.forward * 1, transform.rotation);
			//g.GetComponent<Rigidbody>().AddForce(transform.forward * 100, ForceMode.Impulse);
			int bulletID = currentBallID;// rnd.Next(1, 5000000);
			Bullet b = new Bullet(Client.playerName, bid);
            print("BALL THROW " + bid);
			ballArray[currentBallID].GetComponent<BulletCollider>().bullet = b;
            ballArray[currentBallID].GetComponent<BulletCollider>().exp = exp;
            ballArray[currentBallID].name = bulletID.ToString();
			Client.ClientConnection.ClientShoot(b);
            StartCoroutine(ExecuteAfterTime(4, ballArray[currentBallID]));
            //Destroy(ballArray[currentBallID], 3);


            //Destroy(g, 3);
        }

        /*
        for (var i = 0; i < Input.touchCount; ++i)
        {
            if (Input.GetTouch(i).phase == TouchPhase.Began)
            {
                ballArray[currentBallID].transform.position = mainCamera.transform.position - (mainCamera.transform.up * ballPrefab.transform.localScale.y);
                ballArray[currentBallID].GetComponent<Rigidbody>().velocity = (mainCamera.transform.forward * forwardVelocity) + (mainCamera.transform.up * forwardVelocity / 2);
                ballArray[currentBallID].SetActive(true);
                currentBallID = (currentBallID + 1) % ballArray.Length;
            }
        }*/
    }

    IEnumerator ExecuteAfterTime(float time, GameObject toDestroy) {
        yield return new WaitForSeconds(time);
        toDestroy.SetActive(false);
        // Code to execute after the delay
    }
}
